    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------------------
    028     * SymbolicXYItemLabelGenerator.java
    029     * ---------------------------------
    030     * (C) Copyright 2001-2007, by Anthony Boulestreau and Contributors.
    031     *
    032     * Original Author:  Anthony Boulestreau;
    033     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034     *
    035     * $Id: SymbolicXYItemLabelGenerator.java,v 1.5.2.2 2007/02/02 15:52:42 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 29-Mar-2002 : Version 1, contributed by Anthony Boulestreau (DG);
    040     * 26-Sep-2002 : Fixed errors reported by Checkstyle (DG);
    041     * 23-Mar-2003 : Implemented Serializable (DG);
    042     * 13-Aug-2003 : Implemented Cloneable (DG);
    043     * 17-Nov-2003 : Implemented PublicCloneable (DG);
    044     * 25-Feb-2004 : Renamed XYToolTipGenerator --> XYItemLabelGenerator (DG);
    045     * 19-Jan-2005 : Now accesses primitives only from dataset (DG);
    046     * 20-Apr-2005 : Renamed XYLabelGenerator --> XYItemLabelGenerator (DG);
    047     * 02-Feb-2007 : Removed author tags all over JFreeChart sources (DG);
    048     *
    049     */
    050
    051    package org.jfree.chart.labels;
    052
    053    import java.io.Serializable;
    054
    055    import org.jfree.data.time.RegularTimePeriod;
    056    import org.jfree.data.time.TimeSeriesCollection;
    057    import org.jfree.data.xy.XYDataset;
    058    import org.jfree.data.xy.XisSymbolic;
    059    import org.jfree.data.xy.YisSymbolic;
    060    import org.jfree.util.PublicCloneable;
    061
    062    /**
    063     * A standard item label generator for plots that use data from an
    064     * {@link XYDataset}.
    065     */
    066    public class SymbolicXYItemLabelGenerator implements XYItemLabelGenerator,
    067                                                         XYToolTipGenerator,
    068                                                         Cloneable,
    069                                                         PublicCloneable,
    070                                                         Serializable {
    071
    072        /** For serialization. */
    073        private static final long serialVersionUID = 3963400354475494395L;
    074
    075        /**
    076         * Generates a tool tip text item for a particular item within a series.
    077         *
    078         * @param data  the dataset.
    079         * @param series  the series number (zero-based index).
    080         * @param item  the item number (zero-based index).
    081         *
    082         * @return The tool tip text (possibly <code>null</code>).
    083         */
    084        public String generateToolTip(XYDataset data, int series, int item) {
    085
    086            String xStr, yStr;
    087            if (data instanceof YisSymbolic) {
    088                yStr = ((YisSymbolic) data).getYSymbolicValue(series, item);
    089            }
    090            else {
    091                double y = data.getYValue(series, item);
    092                yStr = Double.toString(round(y, 2));
    093            }
    094            if (data instanceof XisSymbolic) {
    095                xStr = ((XisSymbolic) data).getXSymbolicValue(series, item);
    096            }
    097            else if (data instanceof TimeSeriesCollection) {
    098                RegularTimePeriod p
    099                    = ((TimeSeriesCollection) data).getSeries(series)
    100                        .getTimePeriod(item);
    101                xStr = p.toString();
    102            }
    103            else {
    104                double x = data.getXValue(series, item);
    105                xStr = Double.toString(round(x, 2));
    106            }
    107            return "X: " + xStr + ", Y: " + yStr;
    108        }
    109
    110        /**
    111         * Generates a label for the specified item. The label is typically a
    112         * formatted version of the data value, but any text can be used.
    113         *
    114         * @param dataset  the dataset (<code>null</code> not permitted).
    115         * @param series  the series index (zero-based).
    116         * @param category  the category index (zero-based).
    117         *
    118         * @return The label (possibly <code>null</code>).
    119         */
    120        public String generateLabel(XYDataset dataset, int series, int category) {
    121            return null;  //TODO: implement this method properly
    122        }
    123
    124        /**
    125        * Round a double value.
    126        *
    127        * @param value  the value.
    128        * @param nb  the exponent.
    129        *
    130        * @return The rounded value.
    131        */
    132        private static double round(double value, int nb) {
    133            if (nb <= 0) {
    134                return Math.floor(value + 0.5d);
    135            }
    136            double p = Math.pow(10, nb);
    137            double tempval = Math.floor(value * p + 0.5d);
    138            return tempval / p;
    139        }
    140
    141        /**
    142         * Returns an independent copy of the generator.
    143         *
    144         * @return A clone.
    145         *
    146         * @throws CloneNotSupportedException if cloning is not supported.
    147         */
    148        public Object clone() throws CloneNotSupportedException {
    149            return super.clone();
    150        }
    151
    152        /**
    153         * Tests if this object is equal to another.
    154         *
    155         * @param obj  the other object.
    156         *
    157         * @return A boolean.
    158         */
    159        public boolean equals(Object obj) {
    160            if (obj == this) {
    161                return true;
    162            }
    163            if (obj instanceof SymbolicXYItemLabelGenerator) {
    164                return true;
    165            }
    166            return false;
    167        }
    168
    169    }